1. Packages
  2. Packages
  3. Pulumi Cloud (Pulumi Service provider)
  4. API Docs
  5. api
  6. api/deployments
  7. Settings

This provider is currently in preview.

Viewing docs for Pulumi Cloud v1.1.0
published on Thursday, May 21, 2026 by Pulumi
pulumiservice logo

This provider is currently in preview.

Viewing docs for Pulumi Cloud v1.1.0
published on Thursday, May 21, 2026 by Pulumi

    Creates or updates Pulumi Deployments settings for a stack using a merge operation. If no settings exist, they are created. If settings already exist, the request body is merged with the current settings using the following logic: for each property, start with the current value, remove it if the patch specifies null, or merge the new non-null value with the existing one. Non-object properties (strings, numbers, booleans) are replaced entirely. Settings include source context (git repository URL, branch, directory), operation context (environment variables, pre-run commands, OIDC configuration), executor context, GitHub integration settings, and cache options. Requires a Team Growth or higher subscription. Cannot be used to configure Pulumi Deployments for Terraform stacks.

    Create Settings Resource

    Resources are created with functions called constructors. To learn more about declaring and configuring resources, see Resources.

    Constructor syntax

    new Settings(name: string, args: SettingsArgs, opts?: CustomResourceOptions);
    @overload
    def Settings(resource_name: str,
                 args: SettingsArgs,
                 opts: Optional[ResourceOptions] = None)
    
    @overload
    def Settings(resource_name: str,
                 opts: Optional[ResourceOptions] = None,
                 org_name: Optional[str] = None,
                 project_name: Optional[str] = None,
                 stack_name: Optional[str] = None,
                 agent_pool_id: Optional[str] = None,
                 cache_options: Optional[Any] = None,
                 executor_context: Optional[Any] = None,
                 git_hub: Optional[Any] = None,
                 operation_context: Optional[Any] = None,
                 source_context: Optional[Any] = None,
                 tag: Optional[str] = None,
                 vcs: Optional[Any] = None)
    func NewSettings(ctx *Context, name string, args SettingsArgs, opts ...ResourceOption) (*Settings, error)
    public Settings(string name, SettingsArgs args, CustomResourceOptions? opts = null)
    public Settings(String name, SettingsArgs args)
    public Settings(String name, SettingsArgs args, CustomResourceOptions options)
    
    type: pulumiservice:api/deployments:Settings
    properties: # The arguments to resource properties.
    options: # Bag of options to control resource's behavior.
    
    
    resource "pulumiservice_api_deployments_settings" "name" {
        # resource properties
    }

    Parameters

    name string
    The unique name of the resource.
    args SettingsArgs
    The arguments to resource properties.
    opts CustomResourceOptions
    Bag of options to control resource's behavior.
    resource_name str
    The unique name of the resource.
    args SettingsArgs
    The arguments to resource properties.
    opts ResourceOptions
    Bag of options to control resource's behavior.
    ctx Context
    Context object for the current deployment.
    name string
    The unique name of the resource.
    args SettingsArgs
    The arguments to resource properties.
    opts ResourceOption
    Bag of options to control resource's behavior.
    name string
    The unique name of the resource.
    args SettingsArgs
    The arguments to resource properties.
    opts CustomResourceOptions
    Bag of options to control resource's behavior.
    name String
    The unique name of the resource.
    args SettingsArgs
    The arguments to resource properties.
    options CustomResourceOptions
    Bag of options to control resource's behavior.

    Constructor example

    The following reference example uses placeholder values for all input properties.

    var settingsResource = new PulumiService.Api.Deployments.Settings("settingsResource", new()
    {
        OrgName = "string",
        ProjectName = "string",
        StackName = "string",
        AgentPoolID = "string",
        CacheOptions = "any",
        ExecutorContext = "any",
        GitHub = "any",
        OperationContext = "any",
        SourceContext = "any",
        Tag = "string",
        Vcs = "any",
    });
    
    example, err := deployments.NewSettings(ctx, "settingsResource", &deployments.SettingsArgs{
    	OrgName:          pulumi.String("string"),
    	ProjectName:      pulumi.String("string"),
    	StackName:        pulumi.String("string"),
    	AgentPoolID:      pulumi.String("string"),
    	CacheOptions:     pulumi.Any("any"),
    	ExecutorContext:  pulumi.Any("any"),
    	GitHub:           pulumi.Any("any"),
    	OperationContext: pulumi.Any("any"),
    	SourceContext:    pulumi.Any("any"),
    	Tag:              pulumi.String("string"),
    	Vcs:              pulumi.Any("any"),
    })
    
    resource "pulumiservice_api_deployments_settings" "settingsResource" {
      org_name          = "string"
      project_name      = "string"
      stack_name        = "string"
      agent_pool_id     = "string"
      cache_options     = "any"
      executor_context  = "any"
      git_hub           = "any"
      operation_context = "any"
      source_context    = "any"
      tag               = "string"
      vcs               = "any"
    }
    
    var settingsResource = new Settings("settingsResource", SettingsArgs.builder()
        .orgName("string")
        .projectName("string")
        .stackName("string")
        .agentPoolID("string")
        .cacheOptions("any")
        .executorContext("any")
        .gitHub("any")
        .operationContext("any")
        .sourceContext("any")
        .tag("string")
        .vcs("any")
        .build());
    
    settings_resource = pulumiservice.api.deployments.Settings("settingsResource",
        org_name="string",
        project_name="string",
        stack_name="string",
        agent_pool_id="string",
        cache_options="any",
        executor_context="any",
        git_hub="any",
        operation_context="any",
        source_context="any",
        tag="string",
        vcs="any")
    
    const settingsResource = new pulumiservice.api.deployments.Settings("settingsResource", {
        orgName: "string",
        projectName: "string",
        stackName: "string",
        agentPoolID: "string",
        cacheOptions: "any",
        executorContext: "any",
        gitHub: "any",
        operationContext: "any",
        sourceContext: "any",
        tag: "string",
        vcs: "any",
    });
    
    type: pulumiservice:api/deployments:Settings
    properties:
        agentPoolID: string
        cacheOptions: any
        executorContext: any
        gitHub: any
        operationContext: any
        orgName: string
        projectName: string
        sourceContext: any
        stackName: string
        tag: string
        vcs: any
    

    Settings Resource Properties

    To learn more about resource properties and how to use them, see Inputs and Outputs in the Architecture and Concepts docs.

    Inputs

    In Python, inputs that are objects can be passed either as argument classes or as dictionary literals.

    The Settings resource accepts the following input properties:

    OrgName string
    The organization name
    ProjectName string
    The project name
    StackName string
    The stack name
    AgentPoolID string
    The identifier of the agent pool to use for deployments.
    CacheOptions object
    Cache options for the deployment.
    ExecutorContext object
    The executor context defining the execution environment.
    GitHub object
    GitHub-specific deployment settings
    OperationContext object
    The operation context defining pre-run and post-run commands and environment variables.
    SourceContext object
    The source context defining where the source code is located.
    Tag string
    A tag to identify the deployment settings configuration.
    Vcs object
    VCS provider settings
    OrgName string
    The organization name
    ProjectName string
    The project name
    StackName string
    The stack name
    AgentPoolID string
    The identifier of the agent pool to use for deployments.
    CacheOptions interface{}
    Cache options for the deployment.
    ExecutorContext interface{}
    The executor context defining the execution environment.
    GitHub interface{}
    GitHub-specific deployment settings
    OperationContext interface{}
    The operation context defining pre-run and post-run commands and environment variables.
    SourceContext interface{}
    The source context defining where the source code is located.
    Tag string
    A tag to identify the deployment settings configuration.
    Vcs interface{}
    VCS provider settings
    org_name string
    The organization name
    project_name string
    The project name
    stack_name string
    The stack name
    agent_pool_id string
    The identifier of the agent pool to use for deployments.
    cache_options any
    Cache options for the deployment.
    executor_context any
    The executor context defining the execution environment.
    git_hub any
    GitHub-specific deployment settings
    operation_context any
    The operation context defining pre-run and post-run commands and environment variables.
    source_context any
    The source context defining where the source code is located.
    tag string
    A tag to identify the deployment settings configuration.
    vcs any
    VCS provider settings
    orgName String
    The organization name
    projectName String
    The project name
    stackName String
    The stack name
    agentPoolID String
    The identifier of the agent pool to use for deployments.
    cacheOptions Object
    Cache options for the deployment.
    executorContext Object
    The executor context defining the execution environment.
    gitHub Object
    GitHub-specific deployment settings
    operationContext Object
    The operation context defining pre-run and post-run commands and environment variables.
    sourceContext Object
    The source context defining where the source code is located.
    tag String
    A tag to identify the deployment settings configuration.
    vcs Object
    VCS provider settings
    orgName string
    The organization name
    projectName string
    The project name
    stackName string
    The stack name
    agentPoolID string
    The identifier of the agent pool to use for deployments.
    cacheOptions any
    Cache options for the deployment.
    executorContext any
    The executor context defining the execution environment.
    gitHub any
    GitHub-specific deployment settings
    operationContext any
    The operation context defining pre-run and post-run commands and environment variables.
    sourceContext any
    The source context defining where the source code is located.
    tag string
    A tag to identify the deployment settings configuration.
    vcs any
    VCS provider settings
    org_name str
    The organization name
    project_name str
    The project name
    stack_name str
    The stack name
    agent_pool_id str
    The identifier of the agent pool to use for deployments.
    cache_options Any
    Cache options for the deployment.
    executor_context Any
    The executor context defining the execution environment.
    git_hub Any
    GitHub-specific deployment settings
    operation_context Any
    The operation context defining pre-run and post-run commands and environment variables.
    source_context Any
    The source context defining where the source code is located.
    tag str
    A tag to identify the deployment settings configuration.
    vcs Any
    VCS provider settings
    orgName String
    The organization name
    projectName String
    The project name
    stackName String
    The stack name
    agentPoolID String
    The identifier of the agent pool to use for deployments.
    cacheOptions Any
    Cache options for the deployment.
    executorContext Any
    The executor context defining the execution environment.
    gitHub Any
    GitHub-specific deployment settings
    operationContext Any
    The operation context defining pre-run and post-run commands and environment variables.
    sourceContext Any
    The source context defining where the source code is located.
    tag String
    A tag to identify the deployment settings configuration.
    vcs Any
    VCS provider settings

    Outputs

    All input properties are implicitly available as output properties. Additionally, the Settings resource produces the following output properties:

    Id string
    The provider-assigned unique ID for this managed resource.
    Source string
    The source from which the deployment settings were created.
    Version int
    The version of the deployment settings.
    Id string
    The provider-assigned unique ID for this managed resource.
    Source string
    The source from which the deployment settings were created.
    Version int
    The version of the deployment settings.
    id string
    The provider-assigned unique ID for this managed resource.
    source string
    The source from which the deployment settings were created.
    version number
    The version of the deployment settings.
    id String
    The provider-assigned unique ID for this managed resource.
    source String
    The source from which the deployment settings were created.
    version Integer
    The version of the deployment settings.
    id string
    The provider-assigned unique ID for this managed resource.
    source string
    The source from which the deployment settings were created.
    version number
    The version of the deployment settings.
    id str
    The provider-assigned unique ID for this managed resource.
    source str
    The source from which the deployment settings were created.
    version int
    The version of the deployment settings.
    id String
    The provider-assigned unique ID for this managed resource.
    source String
    The source from which the deployment settings were created.
    version Number
    The version of the deployment settings.

    Package Details

    Repository
    pulumiservice pulumi/pulumi-pulumiservice
    License
    Apache-2.0
    pulumiservice logo

    This provider is currently in preview.

    Viewing docs for Pulumi Cloud v1.1.0
    published on Thursday, May 21, 2026 by Pulumi

      Try Pulumi Cloud free.
      Your team will thank you.

      Start free trial